-- Battle Mod script for Silver
-- jimita: "by using Lua you're already agreeing to bend over to other scripts overriding your code :wonderful:"

local CBW_set
rawset(_G, "silv_CBWBattle", function()
	if CBW_set return end	-- no need to run this

	if CBW_Battle and CBW_Battle.ActionChar
		CBW_set = true

		CBW_Battle.ActionChar["silver"] = function(mo,doaction,pressedaction)
			local p = mo.player

			p.actiontext = "Psycho Shock"
			p.actionrings = 8

			if not CBW_Battle.CanDoAction(p) return end

			-- doaction:
			-- 1 when just pressed
			-- 2 when held
			-- 0 when let go off
			-- -1 when inactive

			if p.cmd.buttons & BT_TOSSFLAG
				doaction = -1	-- no.
			end

			if doaction == -1
				p.actionstate = 0
				p.actiontime = -1

			elseif doaction == 1	-- just pressed
			and p.rings >= p.actionrings	-- can't activate otherwise
				S_StartSound(mo, sfx_s3k84)
				p.actionstate = 1
				p.actiontime = 0
				-- ready usedelay charge:
				mo.silv_pusedelay = TICRATE*3
				mo.silv_usedelay = 2	-- give it 2 frames so it doesn't get unset

				--sfx_s3ka8 for full charge
			elseif doaction == 2	-- held
			and p.actionstate == 1
				p.actiontime = $+1
				mo.silv_usedelay = min(mo.silv_pusedelay, p.actiontime)

				if (leveltime%2)
					local o = P_SpawnMobjFromMobj(mo, P_RandomRange(-128, 128)*mo.scale, P_RandomRange(-128, 128)*mo.scale, P_RandomRange(32, 128)*mo.scale*P_MobjFlip(mo), MT_THOK)
					o.momx = (mo.x - o.x)/6 + mo.momx/2
					o.momy = (mo.y - o.y)/6 + mo.momy/2
					o.momz = ((mo.z + mo.height/2) - o.z)/6 + mo.momz/2
					o.scale = mo.scale/4
					o.tics = 7
					o.color = silv_auracolor(p)
					o.frame = A
				end

				local chargetime = max(4, TICRATE*3 - p.actiontime)
				if (leveltime % chargetime) < 2
					mo.color = silv_auracolor(p)
					mo.colorized = true
				else
					mo.color = p.skincolor
					mo.colorized = false
				end

				if p.actiontime == TICRATE*3
					S_StartSound(mo, sfx_s3ka8)
					local boost = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_THOK)
					boost.angle = mo.angle + ANG1*90
					boost.scale = $/2
					boost.state = S_HOWL1
					boost.color = p.powers[pw_super] and SKINCOLOR_GOLD or silv_auracolor(p)
					boost.destscale = mo.scale*99
					boost.scalespeed = mo.scale/6

				elseif p.actiontime > TICRATE*3
					silv_spawnAura(p)
					if not (p.actiontime % (TICRATE/2))
						p.rings = max(0,$-1)
						S_StartSound(mo, sfx_itemup, p)
					end
				end

				if not p.rings	-- ran out of rings
					-- cancel ability:
					p.actionstate = 0
					p.actiontime = -1
					mo.color = p.skincolor
					S_StartSound(mo, sfx_s3k85)
				end

			elseif doaction == 0	-- let go
			and p.actionstate == 1
				S_StopSound(mo)
				if p.actionstate
					-- spawn the psyshock:
					local atk = P_SPMAngle(mo, MT_PSYSHOCK, mo.angle, p.autoaim ^^ 1)
					if atk and atk.valid	-- walls exist
						atk.color = silv_auracolor(p)
						-- thrust the projectile faster and scale it up depending on p.actiontime
						P_Thrust(atk, atk.angle, min(32*FRACUNIT, p.actiontime / 4 *mo.scale))
						local speed = FixedHypot(atk.momx, atk.momy)

						if p.autoaim
							CBW_Battle.AutoAim(mo, mo.angle, 60, -1, true, atk, speed, MF_BOSS|MF_ENEMY)
						end
						-- used to determine the explosion radius
						atk.storedscalescale = atk.scale + FixedMul(mo.scale, min(2*FRACUNIT, p.actiontime*FRACUNIT / 70))
					end

					CBW_Battle.PayRings(p)
					p.actioncooldown = TICRATE
					S_StartSound(mo, sfx_s3k83)
				end

				mo.color = p.skincolor
				mo.colorized = false
				p.actiontime = -1
				p.actionstate = 0
				-- set the real use delay:
				silv_setUseDelay(mo, TICRATE*3/4)
			end
		end

		-- set priorities
		-- Silver gets top priority when boosting.
		CBW_Battle.AddPriorityFunction("silver_psychoboost", function() return true end)
		-- the rest of the priority function is handled in the PsychoBoost function in Silver_Main.LUA

		-- TKextra setup:

		-- Don't grab Tails'.... thing, but still be able to aim on it.
		silv_addTKextra(MT_BUZZBUDDY, {
			nograb = true
			}
		)

		-- Don't touch Amy's love hearts, it's legit her only attack
		silv_addTKextra(MT_LHRT, {
			nograb = true,
			noaim = true,
			}
		)

		print("\x82".."Succesfully loaded Silver's BattleMod library.")
	end
end)